>From 0c0bd5bbee705d02afe8042edd75c2e860b79e8a Mon Sep 17 00:00:00 2001
From: Guillaume GARDET <guillaume.gardet@opensuse.org>
Date: Tue, 29 Apr 2014 14:01:47 +0200
Subject: [PATCH] Re-eanble ARM kernel in config.conf file and update all ARM
 configs:

* config/arm64/default:
    - Add SATA/PATA support
    - Add voltage and regulator support

* config/armv6hl/default:
    - Add external I2C controllers
    - Add usermode SPI driver

* config/armv7hl/default:
    - Add I2C support for Tegra SoC
    - Add external I2C controllers
    - Add SPI support to Davinci/Keystone SoC
    - Add RTC driver for Tegra and sunxi SoC
    - Enhance nVidia Tegra supprt with MFD_NVEC
    - Add OMAP4 video input support
    - Add IR receiver
    - Add iMX HDMI support
    - Add Serial support for Tegra SoC

* config/armv7hl/exynos:
     - Trivial update

* config/armv7hl/lpae:
    - Add I2C support for Tegra SoC
    - Add external I2C controllers
    - Add SPI support to Davinci/Keystone SoC
    - Remove unused Terga20/Tegra30 SPI support
    - Add RTC driver for Tegra and sunxi SoC
    - Enhance nVidia Tegra supprt with MFD_NVEC
    - Add IR receiver
    - Add iMX HDMI support
    - Add Serial support for Tegra SoC
---
 config.conf            |   10 +++---
 config/arm64/default   |   83 ++++++++++++++++++++++++++++++++++++++++--------
 config/armv6hl/default |   21 ++++++------
 config/armv7hl/default |   52 +++++++++++++++++++-----------
 config/armv7hl/exynos  |    2 +-
 config/armv7hl/lpae    |   47 +++++++++++++++++----------
 6 files changed, 149 insertions(+), 66 deletions(-)

diff --git a/config.conf b/config.conf
index bfea8be..ac4b55c 100644
--- a/config.conf
+++ b/config.conf
@@ -34,11 +34,11 @@
 +ppc64le	ppc64le/vanilla
 
 # ARM architectures
-#+armv6hl	armv6hl/default
-#+armv7hl	armv7hl/default
-#+armv7hl	armv7hl/lpae
-#+armv7hl	armv7hl/exynos
-#+arm64		arm64/default
++armv6hl	armv6hl/default
++armv7hl	armv7hl/default
++armv7hl	armv7hl/lpae
++armv7hl	armv7hl/exynos
++arm64		arm64/default
 
 +s390x		s390x/default
 +s390x		s390x/vanilla
diff --git a/config/arm64/default b/config/arm64/default
index 959b8f0..9eb743d 100644
--- a/config/arm64/default
+++ b/config/arm64/default
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm64 3.14.0 Kernel Configuration
+# Linux/arm64 3.14.2 Kernel Configuration
 #
 CONFIG_ARM64=y
 CONFIG_64BIT=y
@@ -1110,6 +1110,7 @@ CONFIG_WIMAX_DEBUG_LEVEL=8
 CONFIG_RFKILL=m
 CONFIG_RFKILL_LEDS=y
 CONFIG_RFKILL_INPUT=y
+# CONFIG_RFKILL_REGULATOR is not set
 CONFIG_RFKILL_GPIO=m
 CONFIG_NET_9P=m
 CONFIG_NET_9P_VIRTIO=m
@@ -1416,6 +1417,7 @@ CONFIG_SCSI_FC_TGT_ATTRS=y
 CONFIG_SCSI_ISCSI_ATTRS=m
 CONFIG_SCSI_SAS_ATTRS=m
 CONFIG_SCSI_SAS_LIBSAS=m
+# CONFIG_SCSI_SAS_ATA is not set
 CONFIG_SCSI_SAS_HOST_SMP=y
 CONFIG_SCSI_SRP_ATTRS=m
 CONFIG_SCSI_SRP_TGT_ATTRS=y
@@ -1439,7 +1441,43 @@ CONFIG_SCSI_OSD_ULD=m
 CONFIG_SCSI_OSD_DPRINT_SENSE=1
 # CONFIG_SCSI_OSD_DEBUG is not set
 CONFIG_HAVE_PATA_PLATFORM=y
-# CONFIG_ATA is not set
+CONFIG_ATA=m
+# CONFIG_ATA_NONSTANDARD is not set
+CONFIG_ATA_VERBOSE_ERROR=y
+CONFIG_SATA_PMP=y
+
+#
+# Controllers with non-SFF native interface
+#
+CONFIG_SATA_AHCI_PLATFORM=m
+CONFIG_ATA_SFF=y
+
+#
+# SFF controllers with custom DMA interface
+#
+CONFIG_ATA_BMDMA=y
+
+#
+# SATA SFF controllers with BMDMA
+#
+# CONFIG_SATA_HIGHBANK is not set
+# CONFIG_SATA_MV is not set
+# CONFIG_SATA_RCAR is not set
+
+#
+# PATA SFF controllers with BMDMA
+#
+# CONFIG_PATA_ARASAN_CF is not set
+
+#
+# PIO-only SFF controllers
+#
+CONFIG_PATA_PLATFORM=m
+# CONFIG_PATA_OF_PLATFORM is not set
+
+#
+# Generic fallback / legacy drivers
+#
 CONFIG_MD=y
 CONFIG_BLK_DEV_MD=m
 CONFIG_MD_LINEAR=m
@@ -1547,7 +1585,6 @@ CONFIG_NET_VENDOR_I825XX=y
 CONFIG_NET_VENDOR_MARVELL=y
 # CONFIG_MVMDIO is not set
 CONFIG_NET_VENDOR_MICREL=y
-CONFIG_KS8842=m
 CONFIG_KS8851_MLL=m
 CONFIG_NET_VENDOR_NATSEMI=y
 CONFIG_NET_VENDOR_8390=y
@@ -2335,6 +2372,7 @@ CONFIG_CHARGER_ISP1704=m
 CONFIG_CHARGER_MAX8903=m
 # CONFIG_CHARGER_LP8727 is not set
 CONFIG_CHARGER_GPIO=m
+# CONFIG_CHARGER_MANAGER is not set
 # CONFIG_CHARGER_BQ2415X is not set
 # CONFIG_CHARGER_BQ24190 is not set
 # CONFIG_CHARGER_BQ24735 is not set
@@ -2412,7 +2450,6 @@ CONFIG_SENSORS_IT87=m
 # CONFIG_SENSORS_MAX6697 is not set
 # CONFIG_SENSORS_MCP3021 is not set
 CONFIG_SENSORS_NCT6775=m
-CONFIG_SENSORS_NTC_THERMISTOR=m
 CONFIG_SENSORS_PC87360=m
 CONFIG_SENSORS_PC87427=m
 # CONFIG_SENSORS_PCF8591 is not set
@@ -2533,7 +2570,32 @@ CONFIG_MFD_TI_AM335X_TSCADC=m
 # CONFIG_MFD_TMIO is not set
 # CONFIG_MFD_ARIZONA_I2C is not set
 CONFIG_VEXPRESS_CONFIG=y
-# CONFIG_REGULATOR is not set
+CONFIG_REGULATOR=y
+# CONFIG_REGULATOR_DEBUG is not set
+CONFIG_REGULATOR_FIXED_VOLTAGE=m
+# CONFIG_REGULATOR_VIRTUAL_CONSUMER is not set
+# CONFIG_REGULATOR_USERSPACE_CONSUMER is not set
+# CONFIG_REGULATOR_ACT8865 is not set
+# CONFIG_REGULATOR_AD5398 is not set
+# CONFIG_REGULATOR_DA9210 is not set
+# CONFIG_REGULATOR_FAN53555 is not set
+CONFIG_REGULATOR_GPIO=m
+# CONFIG_REGULATOR_ISL6271A is not set
+# CONFIG_REGULATOR_LP3971 is not set
+# CONFIG_REGULATOR_LP3972 is not set
+# CONFIG_REGULATOR_LP872X is not set
+# CONFIG_REGULATOR_LP8755 is not set
+# CONFIG_REGULATOR_MAX1586 is not set
+# CONFIG_REGULATOR_MAX8649 is not set
+# CONFIG_REGULATOR_MAX8660 is not set
+# CONFIG_REGULATOR_MAX8952 is not set
+# CONFIG_REGULATOR_MAX8973 is not set
+# CONFIG_REGULATOR_PFUZE100 is not set
+# CONFIG_REGULATOR_TPS51632 is not set
+# CONFIG_REGULATOR_TPS62360 is not set
+# CONFIG_REGULATOR_TPS65023 is not set
+# CONFIG_REGULATOR_TPS6507X is not set
+CONFIG_REGULATOR_VEXPRESS=m
 CONFIG_MEDIA_SUPPORT=m
 
 #
@@ -2684,7 +2746,6 @@ CONFIG_V4L_PLATFORM_DRIVERS=y
 # CONFIG_VIDEO_TIMBERDALE is not set
 # CONFIG_SOC_CAMERA is not set
 CONFIG_V4L_MEM2MEM_DRIVERS=y
-CONFIG_VIDEO_MEM2MEM_DEINTERLACE=m
 CONFIG_VIDEO_SH_VEU=m
 CONFIG_V4L_TEST_DRIVERS=y
 CONFIG_VIDEO_VIVI=m
@@ -3326,6 +3387,7 @@ CONFIG_LEDS_GPIO=m
 # CONFIG_LEDS_PCA963X is not set
 # CONFIG_LEDS_PCA9685 is not set
 CONFIG_LEDS_PWM=m
+# CONFIG_LEDS_REGULATOR is not set
 # CONFIG_LEDS_BD2802 is not set
 CONFIG_LEDS_LT3593=m
 # CONFIG_LEDS_TCA6507 is not set
@@ -3438,14 +3500,7 @@ CONFIG_DMADEVICES=y
 # CONFIG_DW_DMAC is not set
 # CONFIG_TIMB_DMA is not set
 # CONFIG_PL330_DMA is not set
-CONFIG_DMA_ENGINE=y
 CONFIG_DMA_OF=y
-
-#
-# DMA Clients
-#
-CONFIG_ASYNC_TX_DMA=y
-# CONFIG_DMATEST is not set
 CONFIG_AUXDISPLAY=y
 CONFIG_UIO=m
 CONFIG_UIO_PDRV_GENIRQ=m
@@ -3520,7 +3575,6 @@ CONFIG_TRANZPORT=m
 # CONFIG_LINE6_USB is not set
 CONFIG_USB_SERIAL_QUATECH2=m
 CONFIG_VT6656=m
-# CONFIG_IIO is not set
 CONFIG_USB_ENESTORAGE=m
 # CONFIG_BCM_WIMAX is not set
 CONFIG_FT1000=m
@@ -3610,6 +3664,7 @@ CONFIG_STE_MODEM_RPROC=m
 # CONFIG_PM_DEVFREQ is not set
 # CONFIG_EXTCON is not set
 # CONFIG_MEMORY is not set
+# CONFIG_IIO is not set
 CONFIG_PWM=y
 CONFIG_PWM_SYSFS=y
 # CONFIG_PWM_PCA9685 is not set
diff --git a/config/armv6hl/default b/config/armv6hl/default
index b4f2781..be0d7e7 100644
--- a/config/armv6hl/default
+++ b/config/armv6hl/default
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.14.0 Kernel Configuration
+# Linux/arm 3.14.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -2670,6 +2670,7 @@ CONFIG_I2C_MUX=m
 # CONFIG_I2C_MUX_PCA954x is not set
 # CONFIG_I2C_MUX_PINCTRL is not set
 CONFIG_I2C_HELPER_AUTO=y
+CONFIG_I2C_SMBUS=m
 CONFIG_I2C_ALGOBIT=y
 
 #
@@ -2682,7 +2683,7 @@ CONFIG_I2C_ALGOBIT=y
 CONFIG_I2C_BCM2835=m
 CONFIG_I2C_CBUS_GPIO=m
 # CONFIG_I2C_DESIGNWARE_PLATFORM is not set
-# CONFIG_I2C_GPIO is not set
+CONFIG_I2C_GPIO=m
 CONFIG_I2C_IMX=m
 CONFIG_I2C_KEMPLD=m
 # CONFIG_I2C_NOMADIK is not set
@@ -2697,12 +2698,12 @@ CONFIG_I2C_WMT=m
 #
 # External I2C/SMBus adapter drivers
 #
-# CONFIG_I2C_DIOLAN_U2C is not set
-# CONFIG_I2C_PARPORT is not set
-# CONFIG_I2C_PARPORT_LIGHT is not set
-# CONFIG_I2C_ROBOTFUZZ_OSIF is not set
-# CONFIG_I2C_TAOS_EVM is not set
-# CONFIG_I2C_TINY_USB is not set
+CONFIG_I2C_DIOLAN_U2C=m
+CONFIG_I2C_PARPORT=m
+CONFIG_I2C_PARPORT_LIGHT=m
+CONFIG_I2C_ROBOTFUZZ_OSIF=m
+CONFIG_I2C_TAOS_EVM=m
+CONFIG_I2C_TINY_USB=m
 CONFIG_I2C_VIPERBOARD=m
 
 #
@@ -2723,7 +2724,7 @@ CONFIG_SPI_MASTER=y
 CONFIG_SPI_BCM2835=m
 CONFIG_SPI_BITBANG=m
 # CONFIG_SPI_BUTTERFLY is not set
-# CONFIG_SPI_GPIO is not set
+CONFIG_SPI_GPIO=m
 CONFIG_SPI_IMX=m
 # CONFIG_SPI_LM70_LLP is not set
 # CONFIG_SPI_FSL_SPI is not set
@@ -2740,7 +2741,7 @@ CONFIG_SPI_OMAP24XX=m
 #
 # SPI Protocol Masters
 #
-# CONFIG_SPI_SPIDEV is not set
+CONFIG_SPI_SPIDEV=m
 # CONFIG_SPI_TLE62X0 is not set
 # CONFIG_HSI is not set
 
diff --git a/config/armv7hl/default b/config/armv7hl/default
index 8638a37..64465f7 100644
--- a/config/armv7hl/default
+++ b/config/armv7hl/default
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.14.0 Kernel Configuration
+# Linux/arm 3.14.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -2804,7 +2804,7 @@ CONFIG_SERIAL_AMBA_PL010=m
 CONFIG_SERIAL_AMBA_PL011=y
 CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
 # CONFIG_SERIAL_KGDB_NMI is not set
-# CONFIG_SERIAL_TEGRA is not set
+CONFIG_SERIAL_TEGRA=y
 # CONFIG_SERIAL_MAX3100 is not set
 # CONFIG_SERIAL_MAX310X is not set
 CONFIG_SERIAL_IMX=y
@@ -2882,6 +2882,7 @@ CONFIG_I2C_MUX_PCA9541=m
 CONFIG_I2C_MUX_PCA954x=m
 CONFIG_I2C_MUX_PINCTRL=m
 CONFIG_I2C_HELPER_AUTO=y
+CONFIG_I2C_SMBUS=m
 CONFIG_I2C_ALGOBIT=y
 
 #
@@ -2895,7 +2896,7 @@ CONFIG_I2C_BCM_KONA=m
 CONFIG_I2C_CBUS_GPIO=m
 CONFIG_I2C_DAVINCI=m
 # CONFIG_I2C_DESIGNWARE_PLATFORM is not set
-# CONFIG_I2C_GPIO is not set
+CONFIG_I2C_GPIO=m
 CONFIG_I2C_IMX=m
 CONFIG_I2C_KEMPLD=m
 CONFIG_I2C_MV64XXX=m
@@ -2908,7 +2909,7 @@ CONFIG_I2C_OMAP=y
 CONFIG_I2C_SH_MOBILE=m
 # CONFIG_I2C_SIMTEC is not set
 CONFIG_I2C_ST=m
-# CONFIG_I2C_TEGRA is not set
+CONFIG_I2C_TEGRA=m
 CONFIG_I2C_VERSATILE=m
 CONFIG_I2C_WMT=m
 # CONFIG_I2C_XILINX is not set
@@ -2917,12 +2918,12 @@ CONFIG_I2C_RCAR=m
 #
 # External I2C/SMBus adapter drivers
 #
-# CONFIG_I2C_DIOLAN_U2C is not set
-# CONFIG_I2C_PARPORT is not set
-# CONFIG_I2C_PARPORT_LIGHT is not set
-# CONFIG_I2C_ROBOTFUZZ_OSIF is not set
-# CONFIG_I2C_TAOS_EVM is not set
-# CONFIG_I2C_TINY_USB is not set
+CONFIG_I2C_DIOLAN_U2C=m
+CONFIG_I2C_PARPORT=m
+CONFIG_I2C_PARPORT_LIGHT=m
+CONFIG_I2C_ROBOTFUZZ_OSIF=m
+CONFIG_I2C_TAOS_EVM=m
+CONFIG_I2C_TINY_USB=m
 CONFIG_I2C_VIPERBOARD=m
 
 #
@@ -2942,8 +2943,8 @@ CONFIG_SPI_MASTER=y
 # CONFIG_SPI_ALTERA is not set
 CONFIG_SPI_BITBANG=m
 # CONFIG_SPI_BUTTERFLY is not set
-# CONFIG_SPI_DAVINCI is not set
-# CONFIG_SPI_GPIO is not set
+CONFIG_SPI_DAVINCI=m
+CONFIG_SPI_GPIO=m
 CONFIG_SPI_IMX=m
 # CONFIG_SPI_LM70_LLP is not set
 CONFIG_SPI_FSL_LIB=y
@@ -5011,9 +5012,9 @@ CONFIG_RTC_DRV_IMXDI=y
 CONFIG_RTC_DRV_PL030=y
 CONFIG_RTC_DRV_PL031=y
 CONFIG_RTC_DRV_VT8500=y
-# CONFIG_RTC_DRV_SUNXI is not set
-CONFIG_RTC_DRV_MV=y
-# CONFIG_RTC_DRV_TEGRA is not set
+CONFIG_RTC_DRV_SUNXI=m
+CONFIG_RTC_DRV_MV=m
+CONFIG_RTC_DRV_TEGRA=m
 CONFIG_RTC_DRV_MXC=y
 CONFIG_RTC_DRV_SNVS=y
 CONFIG_RTC_DRV_MOXART=m
@@ -5249,7 +5250,11 @@ CONFIG_SPEAKUP_SYNTH_TXPRT=m
 CONFIG_SPEAKUP_SYNTH_DUMMY=m
 CONFIG_TOUCHSCREEN_CLEARPAD_TM1217=m
 CONFIG_TOUCHSCREEN_SYNAPTICS_I2C_RMI4=m
-# CONFIG_MFD_NVEC is not set
+CONFIG_MFD_NVEC=m
+CONFIG_KEYBOARD_NVEC=m
+CONFIG_SERIO_NVEC_PS2=m
+CONFIG_NVEC_POWER=m
+CONFIG_NVEC_PAZ00=m
 CONFIG_STAGING_MEDIA=y
 # CONFIG_DVB_AS102 is not set
 # CONFIG_I2C_BCM2048 is not set
@@ -5257,8 +5262,17 @@ CONFIG_STAGING_MEDIA=y
 CONFIG_USB_MSI3101=m
 # CONFIG_VIDEO_TCM825X is not set
 CONFIG_USB_SN9C102=m
-# CONFIG_VIDEO_OMAP4 is not set
-# CONFIG_LIRC_STAGING is not set
+CONFIG_VIDEO_OMAP4=y
+# CONFIG_VIDEO_OMAP4_DEBUG is not set
+CONFIG_LIRC_STAGING=y
+CONFIG_LIRC_IGORPLUGUSB=m
+CONFIG_LIRC_IMON=m
+CONFIG_LIRC_PARALLEL=m
+CONFIG_LIRC_SASEM=m
+CONFIG_LIRC_SERIAL=m
+CONFIG_LIRC_SERIAL_TRANSMITTER=y
+CONFIG_LIRC_SIR=m
+CONFIG_LIRC_ZILOG=m
 
 #
 # Android
@@ -5275,7 +5289,7 @@ CONFIG_DRM_IMX_TVE=y
 CONFIG_DRM_IMX_LDB=y
 CONFIG_DRM_IMX_IPUV3_CORE=y
 CONFIG_DRM_IMX_IPUV3=y
-# CONFIG_DRM_IMX_HDMI is not set
+CONFIG_DRM_IMX_HDMI=y
 CONFIG_DGRP=m
 CONFIG_MTD_SPINAND_MT29F=m
 # CONFIG_MTD_SPINAND_ONDIEECC is not set
diff --git a/config/armv7hl/exynos b/config/armv7hl/exynos
index d8ad098..c0cc32c 100644
--- a/config/armv7hl/exynos
+++ b/config/armv7hl/exynos
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.14.0 Kernel Configuration
+# Linux/arm 3.14.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
diff --git a/config/armv7hl/lpae b/config/armv7hl/lpae
index e06a24b..b2ae0bd 100644
--- a/config/armv7hl/lpae
+++ b/config/armv7hl/lpae
@@ -1,6 +1,6 @@
 #
 # Automatically generated file; DO NOT EDIT.
-# Linux/arm 3.14.0 Kernel Configuration
+# Linux/arm 3.14.2 Kernel Configuration
 #
 CONFIG_ARM=y
 CONFIG_MIGHT_HAVE_PCI=y
@@ -2741,6 +2741,7 @@ CONFIG_I2C_MUX_PCA9541=m
 CONFIG_I2C_MUX_PCA954x=m
 CONFIG_I2C_MUX_PINCTRL=m
 CONFIG_I2C_HELPER_AUTO=y
+CONFIG_I2C_SMBUS=m
 CONFIG_I2C_ALGOBIT=y
 
 #
@@ -2753,7 +2754,7 @@ CONFIG_I2C_ALGOBIT=y
 CONFIG_I2C_CBUS_GPIO=m
 CONFIG_I2C_DAVINCI=m
 # CONFIG_I2C_DESIGNWARE_PLATFORM is not set
-# CONFIG_I2C_GPIO is not set
+CONFIG_I2C_GPIO=m
 CONFIG_I2C_IMX=m
 CONFIG_I2C_KEMPLD=m
 CONFIG_I2C_NOMADIK=y
@@ -2762,19 +2763,19 @@ CONFIG_I2C_OMAP=y
 # CONFIG_I2C_PCA_PLATFORM is not set
 # CONFIG_I2C_PXA_PCI is not set
 # CONFIG_I2C_SIMTEC is not set
-# CONFIG_I2C_TEGRA is not set
+CONFIG_I2C_TEGRA=m
 CONFIG_I2C_VERSATILE=m
 # CONFIG_I2C_XILINX is not set
 
 #
 # External I2C/SMBus adapter drivers
 #
-# CONFIG_I2C_DIOLAN_U2C is not set
-# CONFIG_I2C_PARPORT is not set
-# CONFIG_I2C_PARPORT_LIGHT is not set
-# CONFIG_I2C_ROBOTFUZZ_OSIF is not set
-# CONFIG_I2C_TAOS_EVM is not set
-# CONFIG_I2C_TINY_USB is not set
+CONFIG_I2C_DIOLAN_U2C=m
+CONFIG_I2C_PARPORT=m
+CONFIG_I2C_PARPORT_LIGHT=m
+CONFIG_I2C_ROBOTFUZZ_OSIF=m
+CONFIG_I2C_TAOS_EVM=m
+CONFIG_I2C_TINY_USB=m
 CONFIG_I2C_VIPERBOARD=m
 
 #
@@ -2794,7 +2795,7 @@ CONFIG_SPI_MASTER=y
 # CONFIG_SPI_ALTERA is not set
 CONFIG_SPI_BITBANG=m
 # CONFIG_SPI_BUTTERFLY is not set
-# CONFIG_SPI_DAVINCI is not set
+CONFIG_SPI_DAVINCI=m
 # CONFIG_SPI_GPIO is not set
 CONFIG_SPI_IMX=m
 # CONFIG_SPI_LM70_LLP is not set
@@ -2808,8 +2809,8 @@ CONFIG_SPI_TI_QSPI=m
 # CONFIG_SPI_PXA2XX_PCI is not set
 # CONFIG_SPI_SC18IS602 is not set
 CONFIG_SPI_TEGRA114=m
-CONFIG_SPI_TEGRA20_SFLASH=m
-CONFIG_SPI_TEGRA20_SLINK=m
+# CONFIG_SPI_TEGRA20_SFLASH is not set
+# CONFIG_SPI_TEGRA20_SLINK is not set
 # CONFIG_SPI_XCOMM is not set
 # CONFIG_SPI_XILINX is not set
 # CONFIG_SPI_DESIGNWARE is not set
@@ -3170,7 +3171,7 @@ CONFIG_IMX_THERMAL=m
 # Texas Instruments thermal drivers
 #
 CONFIG_TI_SOC_THERMAL=m
-# CONFIG_TI_THERMAL is not set
+CONFIG_TI_THERMAL=y
 CONFIG_OMAP5_THERMAL=y
 CONFIG_DRA752_THERMAL=y
 CONFIG_WATCHDOG=y
@@ -4733,7 +4734,7 @@ CONFIG_RTC_DRV_WM8350=y
 CONFIG_RTC_DRV_IMXDI=y
 CONFIG_RTC_DRV_PL030=y
 CONFIG_RTC_DRV_PL031=y
-# CONFIG_RTC_DRV_TEGRA is not set
+CONFIG_RTC_DRV_TEGRA=y
 CONFIG_RTC_DRV_MXC=y
 CONFIG_RTC_DRV_SNVS=y
 CONFIG_RTC_DRV_MOXART=m
@@ -4959,7 +4960,11 @@ CONFIG_SPEAKUP_SYNTH_TXPRT=m
 CONFIG_SPEAKUP_SYNTH_DUMMY=m
 CONFIG_TOUCHSCREEN_CLEARPAD_TM1217=m
 CONFIG_TOUCHSCREEN_SYNAPTICS_I2C_RMI4=m
-# CONFIG_MFD_NVEC is not set
+CONFIG_MFD_NVEC=m
+CONFIG_KEYBOARD_NVEC=m
+CONFIG_SERIO_NVEC_PS2=m
+CONFIG_NVEC_POWER=m
+CONFIG_NVEC_PAZ00=m
 CONFIG_STAGING_MEDIA=y
 # CONFIG_DVB_AS102 is not set
 # CONFIG_I2C_BCM2048 is not set
@@ -4967,7 +4972,15 @@ CONFIG_STAGING_MEDIA=y
 CONFIG_USB_MSI3101=m
 # CONFIG_VIDEO_TCM825X is not set
 CONFIG_USB_SN9C102=m
-# CONFIG_LIRC_STAGING is not set
+CONFIG_LIRC_STAGING=y
+CONFIG_LIRC_IGORPLUGUSB=m
+CONFIG_LIRC_IMON=m
+CONFIG_LIRC_PARALLEL=m
+CONFIG_LIRC_SASEM=m
+CONFIG_LIRC_SERIAL=m
+CONFIG_LIRC_SERIAL_TRANSMITTER=y
+CONFIG_LIRC_SIR=m
+CONFIG_LIRC_ZILOG=m
 
 #
 # Android
@@ -4984,7 +4997,7 @@ CONFIG_DRM_IMX_TVE=y
 CONFIG_DRM_IMX_LDB=y
 CONFIG_DRM_IMX_IPUV3_CORE=y
 CONFIG_DRM_IMX_IPUV3=y
-# CONFIG_DRM_IMX_HDMI is not set
+CONFIG_DRM_IMX_HDMI=y
 CONFIG_DGRP=m
 CONFIG_MTD_SPINAND_MT29F=m
 # CONFIG_MTD_SPINAND_ONDIEECC is not set
-- 
1.7.10.4