>From 384213613978dc3a17e979a7c088b47cdde6e6eb Mon Sep 17 00:00:00 2001
From: Guillaume GARDET <guillaume.gardet@opensuse.org>
Date: Tue, 15 Apr 2014 09:10:49 +0200
Subject: [PATCH] Update armv7hl configs

---
 config/armv7hl/default |   28 ++++++++++++++++++++++++----
 config/armv7hl/exynos  |   17 ++++++++++++++++-
 config/armv7hl/lpae    |   28 ++++++++++++++++++++++++----
 3 files changed, 64 insertions(+), 9 deletions(-)

diff --git a/config/armv7hl/default b/config/armv7hl/default
index ed78133..7b28c24 100644
--- a/config/armv7hl/default
+++ b/config/armv7hl/default
@@ -1821,7 +1821,7 @@ CONFIG_OF_EARLY_FLATTREE=y
 CONFIG_OF_ADDRESS=y
 CONFIG_OF_IRQ=y
 CONFIG_OF_NET=y
-CONFIG_OF_MDIO=m
+CONFIG_OF_MDIO=y
 CONFIG_OF_MTD=y
 CONFIG_PARPORT=m
 CONFIG_ARCH_MIGHT_HAVE_PC_PARPORT=y
@@ -2206,7 +2206,7 @@ CONFIG_WIZNET_W5300=m
 CONFIG_WIZNET_BUS_ANY=y
 CONFIG_NET_VENDOR_XILINX=y
 CONFIG_XILINX_EMACLITE=m
-CONFIG_PHYLIB=m
+CONFIG_PHYLIB=y
 
 #
 # MII PHY device drivers
@@ -2228,6 +2228,7 @@ CONFIG_NATIONAL_PHY=m
 CONFIG_STE10XP=m
 CONFIG_LSI_ET1011C_PHY=m
 CONFIG_MICREL_PHY=m
+# CONFIG_FIXED_PHY is not set
 CONFIG_MDIO_BITBANG=m
 CONFIG_MDIO_GPIO=m
 CONFIG_MDIO_SUN4I=m
@@ -4517,6 +4518,7 @@ CONFIG_USB_WUSB_CBAF=m
 #
 CONFIG_USB_C67X00_HCD=m
 CONFIG_USB_XHCI_HCD=m
+CONFIG_USB_XHCI_PLATFORM=m
 CONFIG_USB_EHCI_HCD=m
 CONFIG_USB_EHCI_ROOT_HUB_TT=y
 CONFIG_USB_EHCI_TT_NEWSCHED=y
@@ -4603,11 +4605,29 @@ CONFIG_USB_MUSB_AM335X_CHILD=m
 # CONFIG_USB_TI_CPPI41_DMA is not set
 CONFIG_USB_TUSB_OMAP_DMA=y
 # CONFIG_MUSB_PIO_ONLY is not set
-# CONFIG_USB_DWC3 is not set
+CONFIG_USB_DWC3=m
+# CONFIG_USB_DWC3_HOST is not set
+# CONFIG_USB_DWC3_GADGET is not set
+CONFIG_USB_DWC3_DUAL_ROLE=y
+
+#
+# Platform Glue Driver Support
+#
+# CONFIG_USB_DWC3_EXYNOS is not set
+CONFIG_USB_DWC3_KEYSTONE=m
+
+#
+# Debugging features
+#
+# CONFIG_USB_DWC3_DEBUG is not set
 CONFIG_USB_DWC2=m
 # CONFIG_USB_DWC2_DEBUG is not set
 # CONFIG_USB_DWC2_TRACK_MISSED_SOFS is not set
-# CONFIG_USB_CHIPIDEA is not set
+CONFIG_USB_CHIPIDEA=m
+CONFIG_USB_CHIPIDEA_UDC=y
+CONFIG_USB_CHIPIDEA_HOST=y
+# CONFIG_USB_CHIPIDEA_DEBUG is not set
+CONFIG_USB_CHIPIDEA_IMX=y
 
 #
 # USB port drivers
diff --git a/config/armv7hl/exynos b/config/armv7hl/exynos
index bf6bd63..69ca056 100644
--- a/config/armv7hl/exynos
+++ b/config/armv7hl/exynos
@@ -4077,6 +4077,7 @@ CONFIG_USB_WUSB_CBAF=m
 #
 CONFIG_USB_C67X00_HCD=m
 CONFIG_USB_XHCI_HCD=m
+CONFIG_USB_XHCI_PLATFORM=m
 CONFIG_USB_EHCI_HCD=m
 CONFIG_USB_EHCI_ROOT_HUB_TT=y
 CONFIG_USB_EHCI_TT_NEWSCHED=y
@@ -4139,7 +4140,21 @@ CONFIG_USB_STORAGE_ENE_UB6250=m
 CONFIG_USB_MDC800=m
 CONFIG_USB_MICROTEK=m
 # CONFIG_USB_MUSB_HDRC is not set
-# CONFIG_USB_DWC3 is not set
+CONFIG_USB_DWC3=m
+CONFIG_USB_DWC3_HOST=y
+# CONFIG_USB_DWC3_GADGET is not set
+# CONFIG_USB_DWC3_DUAL_ROLE is not set
+
+#
+# Platform Glue Driver Support
+#
+CONFIG_USB_DWC3_EXYNOS=m
+# CONFIG_USB_DWC3_KEYSTONE is not set
+
+#
+# Debugging features
+#
+# CONFIG_USB_DWC3_DEBUG is not set
 CONFIG_USB_DWC2=m
 # CONFIG_USB_DWC2_DEBUG is not set
 # CONFIG_USB_DWC2_TRACK_MISSED_SOFS is not set
diff --git a/config/armv7hl/lpae b/config/armv7hl/lpae
index ef37ceb..1bcb223 100644
--- a/config/armv7hl/lpae
+++ b/config/armv7hl/lpae
@@ -1703,7 +1703,7 @@ CONFIG_OF_EARLY_FLATTREE=y
 CONFIG_OF_ADDRESS=y
 CONFIG_OF_IRQ=y
 CONFIG_OF_NET=y
-CONFIG_OF_MDIO=m
+CONFIG_OF_MDIO=y
 CONFIG_OF_MTD=y
 CONFIG_PARPORT=m
 CONFIG_ARCH_MIGHT_HAVE_PC_PARPORT=y
@@ -2074,7 +2074,7 @@ CONFIG_WIZNET_W5300=m
 # CONFIG_WIZNET_BUS_DIRECT is not set
 # CONFIG_WIZNET_BUS_INDIRECT is not set
 CONFIG_WIZNET_BUS_ANY=y
-CONFIG_PHYLIB=m
+CONFIG_PHYLIB=y
 
 #
 # MII PHY device drivers
@@ -2096,6 +2096,7 @@ CONFIG_NATIONAL_PHY=m
 CONFIG_STE10XP=m
 CONFIG_LSI_ET1011C_PHY=m
 CONFIG_MICREL_PHY=m
+# CONFIG_FIXED_PHY is not set
 CONFIG_MDIO_BITBANG=m
 CONFIG_MDIO_GPIO=m
 CONFIG_MDIO_BUS_MUX=m
@@ -4259,6 +4260,7 @@ CONFIG_USB_WUSB_CBAF=m
 #
 CONFIG_USB_C67X00_HCD=m
 CONFIG_USB_XHCI_HCD=m
+CONFIG_USB_XHCI_PLATFORM=m
 CONFIG_USB_EHCI_HCD=m
 CONFIG_USB_EHCI_ROOT_HUB_TT=y
 CONFIG_USB_EHCI_TT_NEWSCHED=y
@@ -4338,11 +4340,29 @@ CONFIG_USB_MUSB_AM335X_CHILD=m
 # CONFIG_USB_TI_CPPI41_DMA is not set
 CONFIG_USB_TUSB_OMAP_DMA=y
 # CONFIG_MUSB_PIO_ONLY is not set
-# CONFIG_USB_DWC3 is not set
+CONFIG_USB_DWC3=m
+# CONFIG_USB_DWC3_HOST is not set
+# CONFIG_USB_DWC3_GADGET is not set
+CONFIG_USB_DWC3_DUAL_ROLE=y
+
+#
+# Platform Glue Driver Support
+#
+# CONFIG_USB_DWC3_EXYNOS is not set
+CONFIG_USB_DWC3_KEYSTONE=m
+
+#
+# Debugging features
+#
+# CONFIG_USB_DWC3_DEBUG is not set
 CONFIG_USB_DWC2=m
 # CONFIG_USB_DWC2_DEBUG is not set
 # CONFIG_USB_DWC2_TRACK_MISSED_SOFS is not set
-# CONFIG_USB_CHIPIDEA is not set
+CONFIG_USB_CHIPIDEA=m
+CONFIG_USB_CHIPIDEA_UDC=y
+CONFIG_USB_CHIPIDEA_HOST=y
+# CONFIG_USB_CHIPIDEA_DEBUG is not set
+CONFIG_USB_CHIPIDEA_IMX=y
 
 #
 # USB port drivers
-- 
1.7.10.4