diff --git a/config/armv7hl/default b/config/armv7hl/default
index 8c2f101..9028b3a 100644
--- a/config/armv7hl/default
+++ b/config/armv7hl/default
@@ -2758,6 +2758,8 @@ CONFIG_TI_CPSW_PHY_SEL=y
 CONFIG_TI_CPSW_ALE=m
 CONFIG_TI_CPSW=m
 # CONFIG_TI_CPTS is not set
+CONFIG_TI_KEYSTONE_NETCP=m
+CONFIG_TI_KEYSTONE_NETCP_ETHSS=m
 # CONFIG_TLAN is not set
 CONFIG_NET_VENDOR_VIA=y
 CONFIG_VIA_RHINE=m
@@ -3524,6 +3526,7 @@ CONFIG_SERIAL_UARTLITE_CONSOLE=y
 CONFIG_SERIAL_SH_SCI=y
 CONFIG_SERIAL_SH_SCI_NR_UARTS=2
 CONFIG_SERIAL_SH_SCI_CONSOLE=y
+CONFIG_SERIAL_SH_SCI_DMA=y
 CONFIG_SERIAL_CORE=y
 CONFIG_SERIAL_CORE_CONSOLE=y
 CONFIG_CONSOLE_POLL=y
@@ -3560,8 +3563,7 @@ CONFIG_SERIAL_CONEXANT_DIGICOLOR=y
 CONFIG_SERIAL_CONEXANT_DIGICOLOR_CONSOLE=y
 CONFIG_SERIAL_ST_ASC=y
 CONFIG_SERIAL_ST_ASC_CONSOLE=y
-CONFIG_SERIAL_STM32=y
-CONFIG_SERIAL_STM32_CONSOLE=y
+# CONFIG_SERIAL_STM32 is not set
 # CONFIG_TTY_PRINTK is not set
 CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
@@ -3748,6 +3750,7 @@ CONFIG_SPI_S3C64XX=m
 # CONFIG_SPI_SC18IS602 is not set
 CONFIG_SPI_SH_MSIOF=m
 CONFIG_SPI_SH_HSPI=m
+CONFIG_SPI_SIRF=m
 CONFIG_SPI_ST_SSC4=m
 CONFIG_SPI_SUN4I=m
 CONFIG_SPI_SUN6I=m
@@ -3869,8 +3872,8 @@ CONFIG_PINCTRL_MSM8660=m
 CONFIG_PINCTRL_MSM8960=m
 CONFIG_PINCTRL_MSM8X74=m
 CONFIG_PINCTRL_MSM8916=m
-# CONFIG_PINCTRL_QCOM_SPMI_PMIC is not set
-# CONFIG_PINCTRL_QCOM_SSBI_PMIC is not set
+CONFIG_PINCTRL_QCOM_SPMI_PMIC=m
+CONFIG_PINCTRL_QCOM_SSBI_PMIC=m
 CONFIG_PINCTRL_SAMSUNG=y
 CONFIG_PINCTRL_EXYNOS=y
 CONFIG_PINCTRL_EXYNOS5440=y
@@ -4523,7 +4526,7 @@ CONFIG_REGULATOR_VIRTUAL_CONSUMER=m
 CONFIG_REGULATOR_USERSPACE_CONSUMER=m
 CONFIG_REGULATOR_88PM800=m
 CONFIG_REGULATOR_88PM8607=y
-# CONFIG_REGULATOR_ACT8865 is not set
+CONFIG_REGULATOR_ACT8865=m
 CONFIG_REGULATOR_AD5398=m
 CONFIG_REGULATOR_ANATOP=m
 CONFIG_REGULATOR_AAT2870=m
@@ -4572,6 +4575,7 @@ CONFIG_REGULATOR_PBIAS=m
 CONFIG_REGULATOR_PFUZE100=m
 CONFIG_REGULATOR_PWM=m
 CONFIG_REGULATOR_QCOM_RPM=m
+CONFIG_REGULATOR_QCOM_SMD_RPM=m
 CONFIG_REGULATOR_QCOM_SPMI=m
 CONFIG_REGULATOR_RC5T583=m
 CONFIG_REGULATOR_RK808=m
@@ -4915,7 +4919,7 @@ CONFIG_VIDEO_SAMSUNG_S5P_MFC=m
 CONFIG_VIDEO_SAMSUNG_EXYNOS_GSC=m
 CONFIG_VIDEO_STI_BDISP=m
 CONFIG_VIDEO_SH_VEU=m
-# CONFIG_VIDEO_RENESAS_JPU is not set
+CONFIG_VIDEO_RENESAS_JPU=m
 CONFIG_VIDEO_RENESAS_VSP1=m
 CONFIG_VIDEO_TI_VPE=m
 # CONFIG_VIDEO_TI_VPE_DEBUG is not set
@@ -5305,8 +5309,8 @@ CONFIG_DRM_BRIDGE=y
 # Display Interface Bridges
 #
 CONFIG_DRM_DW_HDMI=m
-# CONFIG_DRM_NXP_PTN3460 is not set
-# CONFIG_DRM_PARADE_PS8622 is not set
+CONFIG_DRM_NXP_PTN3460=m
+CONFIG_DRM_PARADE_PS8622=m
 # CONFIG_DRM_STI is not set
 CONFIG_DRM_IMX=m
 CONFIG_DRM_IMX_FB_HELPER=m
@@ -5730,7 +5734,7 @@ CONFIG_SND_SOC_SIRF=m
 CONFIG_SND_SOC_SIRF_AUDIO=m
 CONFIG_SND_SOC_SIRF_AUDIO_PORT=m
 CONFIG_SND_SOC_SIRF_USP=m
-# CONFIG_SND_SOC_STI is not set
+CONFIG_SND_SOC_STI=m
 CONFIG_SND_SOC_TEGRA=m
 CONFIG_SND_SOC_TEGRA20_AC97=m
 CONFIG_SND_SOC_TEGRA20_DAS=m
@@ -6082,9 +6086,9 @@ CONFIG_USBIP_VHCI_HCD=m
 CONFIG_USBIP_HOST=m
 # CONFIG_USBIP_DEBUG is not set
 CONFIG_USB_MUSB_HDRC=m
-CONFIG_USB_MUSB_HOST=y
+# CONFIG_USB_MUSB_HOST is not set
 # CONFIG_USB_MUSB_GADGET is not set
-# CONFIG_USB_MUSB_DUAL_ROLE is not set
+CONFIG_USB_MUSB_DUAL_ROLE=y
 
 #
 # Platform Glue Layer
@@ -6619,7 +6623,7 @@ CONFIG_DMA_VIRTUAL_CHANNELS=y
 CONFIG_DMA_OF=y
 CONFIG_AMBA_PL08X=y
 CONFIG_AXI_DMAC=m
-CONFIG_DMA_OMAP=y
+CONFIG_DMA_OMAP=m
 CONFIG_DMA_SUN4I=m
 CONFIG_DMA_SUN6I=m
 CONFIG_FSL_EDMA=m
@@ -6634,8 +6638,8 @@ CONFIG_MX3_IPU_IRQS=4
 CONFIG_NBPFAXI_DMA=m
 CONFIG_PL330_DMA=y
 CONFIG_QCOM_BAM_DMA=m
-# CONFIG_SIRF_DMA is not set
-# CONFIG_STE_DMA40 is not set
+CONFIG_SIRF_DMA=m
+CONFIG_STE_DMA40=y
 CONFIG_TEGRA20_APB_DMA=y
 CONFIG_TI_CPPI41=m
 CONFIG_TI_DMA_CROSSBAR=y
@@ -6648,11 +6652,12 @@ CONFIG_HSU_DMA=m
 CONFIG_HSU_DMA_PCI=m
 CONFIG_RENESAS_DMA=y
 CONFIG_SH_DMAE_BASE=y
-# CONFIG_SH_DMAE is not set
-# CONFIG_RCAR_DMAC is not set
-# CONFIG_RCAR_HPB_DMAE is not set
-# CONFIG_RENESAS_USB_DMAC is not set
-# CONFIG_SUDMAC is not set
+CONFIG_SH_DMAE=m
+CONFIG_SH_DMAE_R8A73A4=y
+CONFIG_RCAR_DMAC=m
+CONFIG_RCAR_HPB_DMAE=m
+CONFIG_RENESAS_USB_DMAC=m
+CONFIG_SUDMAC=m
 
 #
 # DMA Clients
@@ -7065,15 +7070,17 @@ CONFIG_RPMSG=m
 #
 # SOC (System On Chip) specific Drivers
 #
-# CONFIG_MTK_INFRACFG is not set
-# CONFIG_MTK_PMIC_WRAP is not set
-# CONFIG_MTK_SCPSYS is not set
+CONFIG_MTK_INFRACFG=y
+CONFIG_MTK_PMIC_WRAP=m
+CONFIG_MTK_SCPSYS=y
 CONFIG_QCOM_GSBI=m
 CONFIG_QCOM_PM=y
-# CONFIG_QCOM_SMEM is not set
+CONFIG_QCOM_SMD=m
+CONFIG_QCOM_SMD_RPM=m
+CONFIG_QCOM_SMEM=m
 CONFIG_SUNXI_SRAM=y
 CONFIG_SOC_TI=y
-# CONFIG_KEYSTONE_NAVIGATOR_QMSS is not set
+CONFIG_KEYSTONE_NAVIGATOR_QMSS=m
 CONFIG_KEYSTONE_NAVIGATOR_DMA=m
 CONFIG_PM_DEVFREQ=y
 
@@ -7094,7 +7101,7 @@ CONFIG_PM_DEVFREQ_EVENT=y
 CONFIG_DEVFREQ_EVENT_EXYNOS_PPMU=y
 # CONFIG_EXTCON is not set
 CONFIG_MEMORY=y
-# CONFIG_ARM_PL172_MPMC is not set
+CONFIG_ARM_PL172_MPMC=m
 CONFIG_TI_AEMIF=m
 CONFIG_TI_EMIF=y
 CONFIG_OMAP_GPMC=y
@@ -8175,7 +8182,16 @@ CONFIG_CRYPTO_HW=y
 CONFIG_CRYPTO_DEV_MV_CESA=m
 # CONFIG_CRYPTO_DEV_MARVELL_CESA is not set
 # CONFIG_CRYPTO_DEV_HIFN_795X is not set
-# CONFIG_CRYPTO_DEV_FSL_CAAM is not set
+CONFIG_CRYPTO_DEV_FSL_CAAM=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_JR=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_RINGSIZE=9
+# CONFIG_CRYPTO_DEV_FSL_CAAM_INTC is not set
+CONFIG_CRYPTO_DEV_FSL_CAAM_CRYPTO_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_AHASH_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_RNG_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_IMX=y
+CONFIG_CRYPTO_DEV_FSL_CAAM_LE=y
+# CONFIG_CRYPTO_DEV_FSL_CAAM_DEBUG is not set
 CONFIG_CRYPTO_DEV_OMAP_SHAM=m
 CONFIG_CRYPTO_DEV_OMAP_AES=m
 CONFIG_CRYPTO_DEV_OMAP_DES=m
diff --git a/config/armv7hl/lpae b/config/armv7hl/lpae
index cbc0abf..556b504 100644
--- a/config/armv7hl/lpae
+++ b/config/armv7hl/lpae
@@ -398,7 +398,6 @@ CONFIG_ARCH_MESON=y
 # CONFIG_MACH_MESON8 is not set
 CONFIG_ARCH_MXC=y
 CONFIG_HAVE_IMX_ANATOP=y
-CONFIG_HAVE_IMX_GPC=y
 CONFIG_HAVE_IMX_MMDC=y
 CONFIG_HAVE_IMX_SRC=y
 
@@ -412,11 +411,10 @@ CONFIG_HAVE_IMX_SRC=y
 # CONFIG_SOC_IMX50 is not set
 # CONFIG_SOC_IMX51 is not set
 # CONFIG_SOC_IMX53 is not set
-CONFIG_SOC_IMX6=y
 # CONFIG_SOC_IMX6Q is not set
 # CONFIG_SOC_IMX6SL is not set
 # CONFIG_SOC_IMX6SX is not set
-CONFIG_SOC_IMX6UL=y
+# CONFIG_SOC_IMX6UL is not set
 CONFIG_SOC_IMX7D=y
 CONFIG_SOC_LS1021A=y
 
@@ -3225,7 +3223,7 @@ CONFIG_TOUCHSCREEN_MAX11801=m
 CONFIG_TOUCHSCREEN_MCS5000=m
 CONFIG_TOUCHSCREEN_MMS114=m
 CONFIG_TOUCHSCREEN_MTOUCH=m
-CONFIG_TOUCHSCREEN_IMX6UL_TSC=m
+# CONFIG_TOUCHSCREEN_IMX6UL_TSC is not set
 CONFIG_TOUCHSCREEN_INEXIO=m
 CONFIG_TOUCHSCREEN_MK712=m
 CONFIG_TOUCHSCREEN_PENMOUNT=m
@@ -3416,6 +3414,7 @@ CONFIG_SERIAL_IMX_CONSOLE=y
 CONFIG_SERIAL_SH_SCI=y
 CONFIG_SERIAL_SH_SCI_NR_UARTS=2
 CONFIG_SERIAL_SH_SCI_CONSOLE=y
+CONFIG_SERIAL_SH_SCI_DMA=y
 CONFIG_SERIAL_CORE=y
 CONFIG_SERIAL_CORE_CONSOLE=y
 CONFIG_CONSOLE_POLL=y
@@ -3441,8 +3440,7 @@ CONFIG_SERIAL_FSL_LPUART=y
 CONFIG_SERIAL_FSL_LPUART_CONSOLE=y
 # CONFIG_SERIAL_CONEXANT_DIGICOLOR is not set
 # CONFIG_SERIAL_ST_ASC is not set
-CONFIG_SERIAL_STM32=y
-CONFIG_SERIAL_STM32_CONSOLE=y
+# CONFIG_SERIAL_STM32 is not set
 # CONFIG_TTY_PRINTK is not set
 CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
@@ -3539,7 +3537,7 @@ CONFIG_I2C_DAVINCI=m
 CONFIG_I2C_DESIGNWARE_CORE=m
 CONFIG_I2C_DESIGNWARE_PLATFORM=m
 # CONFIG_I2C_DESIGNWARE_PCI is not set
-CONFIG_I2C_EMEV2=m
+# CONFIG_I2C_EMEV2 is not set
 CONFIG_I2C_EXYNOS5=m
 CONFIG_I2C_GPIO=m
 CONFIG_I2C_IMX=m
@@ -3626,7 +3624,7 @@ CONFIG_SPI_TEGRA114=m
 # CONFIG_SPI_TEGRA20_SLINK is not set
 # CONFIG_SPI_XCOMM is not set
 # CONFIG_SPI_XILINX is not set
-CONFIG_SPI_ZYNQMP_GQSPI=m
+# CONFIG_SPI_ZYNQMP_GQSPI is not set
 CONFIG_SPI_DESIGNWARE=m
 # CONFIG_SPI_DW_PCI is not set
 CONFIG_SPI_DW_MMIO=m
@@ -3696,7 +3694,6 @@ CONFIG_PINCTRL_TEGRA124=y
 CONFIG_PINCTRL_TEGRA_XUSB=y
 CONFIG_PINCTRL_PALMAS=y
 CONFIG_PINCTRL_IMX=y
-CONFIG_PINCTRL_IMX6UL=y
 CONFIG_PINCTRL_IMX7D=y
 CONFIG_PINCTRL_MSM=y
 CONFIG_PINCTRL_APQ8064=m
@@ -3705,9 +3702,9 @@ CONFIG_PINCTRL_IPQ8064=m
 CONFIG_PINCTRL_MSM8660=m
 CONFIG_PINCTRL_MSM8960=m
 CONFIG_PINCTRL_MSM8X74=m
-CONFIG_PINCTRL_MSM8916=m
+# CONFIG_PINCTRL_MSM8916 is not set
 CONFIG_PINCTRL_QCOM_SPMI_PMIC=m
-# CONFIG_PINCTRL_QCOM_SSBI_PMIC is not set
+CONFIG_PINCTRL_QCOM_SSBI_PMIC=m
 CONFIG_PINCTRL_SAMSUNG=y
 CONFIG_PINCTRL_EXYNOS=y
 CONFIG_PINCTRL_EXYNOS5440=y
@@ -3910,7 +3907,6 @@ CONFIG_POWER_RESET_AXXIA=y
 CONFIG_POWER_RESET_GPIO=y
 CONFIG_POWER_RESET_GPIO_RESTART=y
 CONFIG_POWER_RESET_HISI=y
-CONFIG_POWER_RESET_IMX=y
 CONFIG_POWER_RESET_MSM=y
 CONFIG_POWER_RESET_LTC2952=y
 CONFIG_POWER_RESET_RESTART=y
@@ -4363,6 +4359,7 @@ CONFIG_REGULATOR_PBIAS=m
 CONFIG_REGULATOR_PFUZE100=m
 CONFIG_REGULATOR_PWM=m
 CONFIG_REGULATOR_QCOM_RPM=m
+# CONFIG_REGULATOR_QCOM_SMD_RPM is not set
 CONFIG_REGULATOR_QCOM_SPMI=m
 CONFIG_REGULATOR_RC5T583=m
 CONFIG_REGULATOR_RK808=m
@@ -4666,9 +4663,10 @@ CONFIG_V4L_PLATFORM_DRIVERS=y
 # CONFIG_VIDEO_CAFE_CCIC is not set
 # CONFIG_VIDEO_SH_VOU is not set
 CONFIG_SOC_CAMERA=m
+CONFIG_SOC_CAMERA_SCALE_CROP=m
 CONFIG_SOC_CAMERA_PLATFORM=m
 # CONFIG_VIDEO_MX3 is not set
-# CONFIG_VIDEO_RCAR_VIN is not set
+CONFIG_VIDEO_RCAR_VIN=m
 # CONFIG_VIDEO_SH_MOBILE_CSI2 is not set
 # CONFIG_VIDEO_SH_MOBILE_CEU is not set
 # CONFIG_VIDEO_SAMSUNG_EXYNOS4_IS is not set
@@ -4684,8 +4682,8 @@ CONFIG_VIDEO_SAMSUNG_S5P_JPEG=m
 CONFIG_VIDEO_SAMSUNG_S5P_MFC=m
 CONFIG_VIDEO_SAMSUNG_EXYNOS_GSC=m
 # CONFIG_VIDEO_SH_VEU is not set
-# CONFIG_VIDEO_RENESAS_JPU is not set
-# CONFIG_VIDEO_RENESAS_VSP1 is not set
+CONFIG_VIDEO_RENESAS_JPU=m
+CONFIG_VIDEO_RENESAS_VSP1=m
 CONFIG_VIDEO_TI_VPE=m
 # CONFIG_VIDEO_TI_VPE_DEBUG is not set
 CONFIG_V4L_TEST_DRIVERS=y
@@ -5074,8 +5072,8 @@ CONFIG_DRM_BRIDGE=y
 #
 # Display Interface Bridges
 #
-# CONFIG_DRM_NXP_PTN3460 is not set
-# CONFIG_DRM_PARADE_PS8622 is not set
+CONFIG_DRM_NXP_PTN3460=m
+CONFIG_DRM_PARADE_PS8622=m
 # CONFIG_DRM_STI is not set
 
 #
@@ -5784,9 +5782,9 @@ CONFIG_USBIP_VHCI_HCD=m
 CONFIG_USBIP_HOST=m
 # CONFIG_USBIP_DEBUG is not set
 CONFIG_USB_MUSB_HDRC=m
-CONFIG_USB_MUSB_HOST=y
+# CONFIG_USB_MUSB_HOST is not set
 # CONFIG_USB_MUSB_GADGET is not set
-# CONFIG_USB_MUSB_DUAL_ROLE is not set
+CONFIG_USB_MUSB_DUAL_ROLE=y
 
 #
 # Platform Glue Layer
@@ -6032,7 +6030,7 @@ CONFIG_MMC_SDHCI_IO_ACCESSORS=y
 # CONFIG_MMC_SDHCI_PCI is not set
 CONFIG_MMC_SDHCI_PLTFM=m
 # CONFIG_MMC_SDHCI_OF_ARASAN is not set
-CONFIG_MMC_SDHCI_OF_AT91=m
+# CONFIG_MMC_SDHCI_OF_AT91 is not set
 # CONFIG_MMC_SDHCI_ESDHC_IMX is not set
 CONFIG_MMC_SDHCI_TEGRA=m
 CONFIG_MMC_SDHCI_S3C=m
@@ -6320,11 +6318,12 @@ CONFIG_HSU_DMA=m
 CONFIG_HSU_DMA_PCI=m
 CONFIG_RENESAS_DMA=y
 CONFIG_SH_DMAE_BASE=y
-# CONFIG_SH_DMAE is not set
-# CONFIG_RCAR_DMAC is not set
+CONFIG_SH_DMAE=m
+CONFIG_SH_DMAE_R8A73A4=y
+CONFIG_RCAR_DMAC=m
 CONFIG_RCAR_HPB_DMAE=m
-# CONFIG_RENESAS_USB_DMAC is not set
-# CONFIG_SUDMAC is not set
+CONFIG_RENESAS_USB_DMAC=m
+CONFIG_SUDMAC=m
 
 #
 # DMA Clients
@@ -6714,7 +6713,9 @@ CONFIG_RPMSG=m
 # CONFIG_MTK_SCPSYS is not set
 CONFIG_QCOM_GSBI=m
 CONFIG_QCOM_PM=y
-# CONFIG_QCOM_SMEM is not set
+CONFIG_QCOM_SMD=m
+CONFIG_QCOM_SMD_RPM=m
+CONFIG_QCOM_SMEM=m
 CONFIG_SUNXI_SRAM=y
 CONFIG_SOC_TI=y
 # CONFIG_KEYSTONE_NAVIGATOR_QMSS is not set
@@ -6738,7 +6739,7 @@ CONFIG_PM_DEVFREQ_EVENT=y
 CONFIG_DEVFREQ_EVENT_EXYNOS_PPMU=y
 # CONFIG_EXTCON is not set
 CONFIG_MEMORY=y
-# CONFIG_ARM_PL172_MPMC is not set
+CONFIG_ARM_PL172_MPMC=m
 CONFIG_TI_AEMIF=m
 CONFIG_TI_EMIF=y
 CONFIG_OMAP_GPMC=y
@@ -7784,7 +7785,16 @@ CONFIG_CRYPTO_USER_API_RNG=m
 CONFIG_CRYPTO_USER_API_AEAD=m
 CONFIG_CRYPTO_HASH_INFO=y
 CONFIG_CRYPTO_HW=y
-# CONFIG_CRYPTO_DEV_FSL_CAAM is not set
+CONFIG_CRYPTO_DEV_FSL_CAAM=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_JR=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_RINGSIZE=9
+# CONFIG_CRYPTO_DEV_FSL_CAAM_INTC is not set
+CONFIG_CRYPTO_DEV_FSL_CAAM_CRYPTO_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_AHASH_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_RNG_API=m
+CONFIG_CRYPTO_DEV_FSL_CAAM_IMX=y
+CONFIG_CRYPTO_DEV_FSL_CAAM_LE=y
+# CONFIG_CRYPTO_DEV_FSL_CAAM_DEBUG is not set
 CONFIG_CRYPTO_DEV_OMAP_SHAM=m
 CONFIG_CRYPTO_DEV_OMAP_AES=m
 CONFIG_CRYPTO_DEV_OMAP_DES=m
diff --git a/config/armv7hl/vanilla b/config/armv7hl/vanilla
index f82f4bc..a35a56b 100644
--- a/config/armv7hl/vanilla
+++ b/config/armv7hl/vanilla
@@ -28,9 +28,7 @@ CONFIG_ARM_PATCH_PHYS_VIRT=y
 CONFIG_GENERIC_BUG=y
 CONFIG_PGTABLE_LEVELS=2
 CONFIG_SUSE_KERNEL=y
-# CONFIG_SUSE_KERNEL_SUPPORTED is not set
 CONFIG_SPLIT_PACKAGE=y
-# CONFIG_KERNEL_DESKTOP is not set
 CONFIG_DEFCONFIG_LIST="/lib/modules/$UNAME_RELEASE/.config"
 CONFIG_IRQ_WORK=y
 CONFIG_BUILDTIME_EXTABLE_SORT=y
@@ -1113,7 +1111,6 @@ CONFIG_NF_CONNTRACK_PPTP=m
 CONFIG_NF_CONNTRACK_SANE=m
 CONFIG_NF_CONNTRACK_SIP=m
 CONFIG_NF_CONNTRACK_TFTP=m
-CONFIG_NF_CONNTRACK_SLP=m
 CONFIG_NF_CT_NETLINK=m
 CONFIG_NF_CT_NETLINK_TIMEOUT=m
 CONFIG_NF_CT_NETLINK_HELPER=m
@@ -3560,8 +3557,7 @@ CONFIG_SERIAL_CONEXANT_DIGICOLOR=y
 CONFIG_SERIAL_CONEXANT_DIGICOLOR_CONSOLE=y
 CONFIG_SERIAL_ST_ASC=y
 CONFIG_SERIAL_ST_ASC_CONSOLE=y
-CONFIG_SERIAL_STM32=y
-CONFIG_SERIAL_STM32_CONSOLE=y
+# CONFIG_SERIAL_STM32 is not set
 # CONFIG_TTY_PRINTK is not set
 CONFIG_PRINTER=m
 # CONFIG_LP_CONSOLE is not set
@@ -3600,7 +3596,6 @@ CONFIG_TCG_TIS_ST33ZP24=m
 CONFIG_TCG_TIS_ST33ZP24_I2C=m
 CONFIG_TCG_TIS_ST33ZP24_SPI=m
 CONFIG_DEVPORT=y
-CONFIG_CRASHER=m
 CONFIG_XILLYBUS=m
 # CONFIG_XILLYBUS_PCIE is not set
 CONFIG_XILLYBUS_OF=m
@@ -3868,9 +3863,9 @@ CONFIG_PINCTRL_IPQ8064=m
 CONFIG_PINCTRL_MSM8660=m
 CONFIG_PINCTRL_MSM8960=m
 CONFIG_PINCTRL_MSM8X74=m
-CONFIG_PINCTRL_MSM8916=m
-# CONFIG_PINCTRL_QCOM_SPMI_PMIC is not set
-# CONFIG_PINCTRL_QCOM_SSBI_PMIC is not set
+# CONFIG_PINCTRL_MSM8916 is not set
+CONFIG_PINCTRL_QCOM_SPMI_PMIC=m
+CONFIG_PINCTRL_QCOM_SSBI_PMIC=m
 CONFIG_PINCTRL_SAMSUNG=y
 CONFIG_PINCTRL_EXYNOS=y
 CONFIG_PINCTRL_EXYNOS5440=y
@@ -4523,7 +4518,7 @@ CONFIG_REGULATOR_VIRTUAL_CONSUMER=m
 CONFIG_REGULATOR_USERSPACE_CONSUMER=m
 CONFIG_REGULATOR_88PM800=m
 CONFIG_REGULATOR_88PM8607=y
-# CONFIG_REGULATOR_ACT8865 is not set
+CONFIG_REGULATOR_ACT8865=m
 CONFIG_REGULATOR_AD5398=m
 CONFIG_REGULATOR_ANATOP=m
 CONFIG_REGULATOR_AAT2870=m
@@ -4915,7 +4910,7 @@ CONFIG_VIDEO_SAMSUNG_S5P_MFC=m
 CONFIG_VIDEO_SAMSUNG_EXYNOS_GSC=m
 CONFIG_VIDEO_STI_BDISP=m
 CONFIG_VIDEO_SH_VEU=m
-# CONFIG_VIDEO_RENESAS_JPU is not set
+CONFIG_VIDEO_RENESAS_JPU=m
 CONFIG_VIDEO_RENESAS_VSP1=m
 CONFIG_VIDEO_TI_VPE=m
 # CONFIG_VIDEO_TI_VPE_DEBUG is not set
@@ -5305,8 +5300,8 @@ CONFIG_DRM_BRIDGE=y
 # Display Interface Bridges
 #
 CONFIG_DRM_DW_HDMI=m
-# CONFIG_DRM_NXP_PTN3460 is not set
-# CONFIG_DRM_PARADE_PS8622 is not set
+CONFIG_DRM_NXP_PTN3460=m
+CONFIG_DRM_PARADE_PS8622=m
 # CONFIG_DRM_STI is not set
 CONFIG_DRM_IMX=m
 CONFIG_DRM_IMX_FB_HELPER=m
@@ -5730,7 +5725,7 @@ CONFIG_SND_SOC_SIRF=m
 CONFIG_SND_SOC_SIRF_AUDIO=m
 CONFIG_SND_SOC_SIRF_AUDIO_PORT=m
 CONFIG_SND_SOC_SIRF_USP=m
-# CONFIG_SND_SOC_STI is not set
+CONFIG_SND_SOC_STI=m
 CONFIG_SND_SOC_TEGRA=m
 CONFIG_SND_SOC_TEGRA20_AC97=m
 CONFIG_SND_SOC_TEGRA20_DAS=m
@@ -6004,7 +5999,6 @@ CONFIG_USB_EHCI_HCD_OMAP=m
 CONFIG_USB_EHCI_HCD_ORION=m
 CONFIG_USB_EHCI_HCD_SPEAR=m
 CONFIG_USB_EHCI_HCD_STI=m
-# CONFIG_USB_EHCI_HCD_SYNOPSYS is not set
 CONFIG_USB_EHCI_MSM=m
 CONFIG_USB_EHCI_TEGRA=m
 CONFIG_USB_EHCI_EXYNOS=m
@@ -6082,9 +6076,9 @@ CONFIG_USBIP_VHCI_HCD=m
 CONFIG_USBIP_HOST=m
 # CONFIG_USBIP_DEBUG is not set
 CONFIG_USB_MUSB_HDRC=m
-CONFIG_USB_MUSB_HOST=y
+# CONFIG_USB_MUSB_HOST is not set
 # CONFIG_USB_MUSB_GADGET is not set
-# CONFIG_USB_MUSB_DUAL_ROLE is not set
+CONFIG_USB_MUSB_DUAL_ROLE=y
 
 #
 # Platform Glue Layer