diff --git a/opensuse-trademark-guidelines.txt b/opensuse-trademark-guidelines.txt
index 437f814..1370e0a 100644
--- a/opensuse-trademark-guidelines.txt
+++ b/opensuse-trademark-guidelines.txt
@@ -32,6 +32,16 @@ and do not mean to suggest with these Guidelines that our permission is required
 in such cases. We cannot, however, tell you categorically what will and will not
 qualify as a "fair use."
 
+=== Contributing to openSUSE ===
+
+We encourage everybody to contribute to openSUSE and become part of the openSUSE
+community. Contributors don't have to be employees of the owner of the openSUSE
+trademark or openSUSE members.
+
+If your contributions require trademark usage which is not permitted by these
+guidelines, please don't hesitate to contact us (see "Contact Information"
+below).
+
 == Use Cases for the openSUSE Marks ==
 
 === Redistributing openSUSE Without Modifications ===
@@ -40,62 +50,41 @@ You may use the openSUSE Marks to identify your redistribution of openSUSE with
 no modifications, meaning you are redistributing an official distribution from
 the openSUSE Project that has not been changed in any way.
 
-=== Distributing openSUSE With Project-Based Modifications ===
+=== Distributing openSUSE With Modifications ===
 
-You may distribute openSUSE with project-based modifications, meaning you are
-distributing an unmodified binary openSUSE bootstrap core from the official
-openSUSE Project repositories, along with additional unmodified binary packages
-drawn exclusively from those same repositories. Such distributions can be
+You may distribute openSUSE with modifications. Such distributions can be
 created via SUSE Studio, KIWI, or the openSUSE Build Service, or via your own
-build process. 
+build process.
 
 In making such a distribution, you must remove all trademark uses of the
-openSUSE Marks from the version of openSUSE you are modifying, and must use your
-own trademark instead. You may, if you wish, combine your trademark with one of
+openSUSE Marks from the version of openSUSE you are modifying.
+You may, if you wish, combine your own trademark with one of
 the following openSUSE Mark tag-lines (or its equivalent): "Based on openSUSE";
 "Powered by openSUSE"; "Derived from openSUSE"; "Uses openSUSE"; "Built on
-openSUSE"; or "Built from openSUSE". Partial instructions on how to remove some
-trademark uses of the openSUSE Marks from openSUSE are provided below.
-
-=== Distributing openSUSE With All Other Modifications ===
-
-You may not use the openSUSE Marks, or the openSUSE Mark tag-lines (or their
-equivalents) described above, to identify your distribution of openSUSE with any
-modifications other than project-based modifications as described above. To
-distribute openSUSE with any modifications other than project-based
-modifications, you must remove all trademark uses of the openSUSE Marks from the
-version of openSUSE you are modifying. Partial instructions on how to remove
-some trademark uses of the openSUSE Marks from openSUSE are provided below. Note
-that if you are including packages in your distribution that are not from the
-official openSUSE Project repositories, we encourage you to work within the
-openSUSE community to submit and maintain those packages within those
-repositories.
+openSUSE"; or "Built from openSUSE".
 
-=== Partial Instructions for Removing openSUSE Marks from openSUSE ===
+openSUSE provides a special set of branding packages for modified openSUSE
+versions. You may replace the official openSUSE branding packages by them, or
+you have to remove the official openSUSE branding packages on your modified
+version of openSUSE. In technical terms it means that for every packages which
+name ends with branding-openSUSE you have to either remove it, or replace it by
+the corresponding package, which name ends with branding-based-on-openSUSE.
 
 Partial instructions on how to remove some trademark uses of the openSUSE Marks
 from openSUSE can be found at [[SDB:Making_an_openSUSE_based_distribution|Making
-an openSUSE based distribution]]. We supplement these instructions with the
-following additional guidance.
-
-Generally, you will need to remove the files and packages identified by
-Rembrand. You will also need to remove the following packages:
-bootsplash-branding-openSUSE; branding-openSUSE; compiz-branding-openSUSE;
-epiphanybranding- openSUSE; gconf2-branding-openSUSE; gdm-branding-openSUSE;
-gfxboot-branding-openSUSE; gimp-brandingopenSUSE; glib2-branding-openSUSE;
-gnome-menus-branding-openSUSE; gtk2-branding-openSUSE; install-initrdbranding-
-openSUSE; MozillaFirefox-branding-openSUSE; pidgin-branding-openSUSE;
-splashy-branding-openSUSE; xfce4- desktop-branding-openSUSE; and
-yast2-branding-openSUSE. Further, you will need to remove all logos, wallpapers,
-splash-screens, boot menu graphics, installer branding, marks, language, and
-other uses that indicate the system is "openSUSE." Of course, in the case of
-a distribution of openSUSE with project-based modifications, language or marks
-that make use of the openSUSE Mark tag-lines described above may remain in the
-distribution. Finally, you generally will not need to remove or modify package
+an openSUSE based distribution]].
+
+You generally will not need to remove or modify package
 headers, notes, README files, Changelogs, or other files containing uses of the
 openSUSE Marks that merely describe the openSUSE project, as long as such uses
 do not imply that you are formally affiliated with the openSUSE Project.
 
+Note
+that if you are including packages in your distribution that are not from the
+official openSUSE Project repositories, we encourage you to work within the
+openSUSE community to submit and maintain those packages within those
+repositories.
+
 === Linking to opensuse.org ===
 
 We are pleased to permit you to link to opensuse.org from your web site. We have
@@ -121,15 +110,12 @@ immediately remove the logos from your web site.
 
 === Merchandise ===
 
-When it comes to the openSUSE Marks, there are some cool things you can do and
-some cool things you can't do - at least not without asking us. You may make
-t-shirts, hats, bags, jackets, sweatshirts, mugs, and desktop wallpaper with the
-openSUSE Marks on them, though only for yourself and your friends (meaning
-people from whom you don't receive anything of value in return). You can't put
-the openSUSE Marks on anything you produce commercially, or at least not without
-receiving our permission (see "Contact Information" below to request
-permission). Also, we provide the openSUSE Shop, which sells a wide range of
-products with the openSUSE Marks.
+You are welcome to make use of the openSUSE Marks to produce merchandise such as
+t-shirts, hats, bags, jackets, sweatshirts, mugs, and desktop wallpapers and
+give them to your friends, family, community members, provided there is no
+commercial interest behind it. You have to request permission if you want to
+commercially distribute articles using the openSUSE Marks (see "Contact
+Information" below to request permission).
 
 === Domain Names ===
 
@@ -170,12 +156,16 @@ distribute openSUSE media, or otherwise represent the Project, provided:
 * You do not disparage the openSUSE Project using the openSUSE Marks; and
 * Your use of the openSUSE Marks is not deceptive or false in any regard.  
 
+Individuals can be openSUSE members, members of the wider openSUSE community, or
+openSUSE users.
+
 === Publications ===
 
-If you want to include all or part of an openSUSE Mark in the title or subtitle
-of a publication such as a book or magazine, you should seek our permission (see
-"Contact Information" below to request permission).
- 
+If you want to include all or part of an openSUSE Mark in the name
+of a publication such as a book or magazine, you need our permission (see
+"Contact Information" below to request permission). But you can use the openSUSE
+Mark in e.g. a title of review inside a magazine.
+
 === Product and Service Names, and Compatibility References ===
 
 You should not include an openSUSE Mark in the name of your product or service,
@@ -239,7 +229,7 @@ available to discuss terms for use.
 == Contact Information ==
 
 You may contact us regarding these Guidelines, including regarding requests for
-permission, at permission@novell.com.
+permission, at trademark@opensuse.org.
 
 == License for these Guidelines ==
 